# coding: utf-8

"""
    SendX REST API

    # Introduction SendX is an email marketing product. It helps you convert website visitors to customers, send them promotional emails, engage with them using drip sequences and craft custom journeys using powerful but simple automations. The SendX API is organized around REST. Our API has predictable resource-oriented URLs, accepts form-encoded request bodies, returns JSON-encoded responses, and uses standard HTTP response codes, authentication, and verbs. The SendX Rest API doesn’t support bulk updates. You can work on only one object per request. <br> 

    The version of the OpenAPI document: 1.0.1
    Contact: support@sendx.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class ListRequest(BaseModel):
    """
    ListRequest
    """ # noqa: E501
    name: Optional[StrictStr] = Field(default=None, description="Name of the list")
    type: Optional[StrictInt] = Field(default=None, description="Type of the list representing opt-in methods <br> 0: Single opt-in list <br> 1: Double opt-in list ")
    send_thank_you_mail: Optional[StrictBool] = Field(default=None, description="Indicates if a thank-you email should be sent", alias="sendThankYouMail")
    thank_you_from_name: Optional[StrictStr] = Field(default=None, description="Name displayed as the sender in the thank-you email", alias="thankYouFromName")
    thank_you_from_email: Optional[StrictStr] = Field(default=None, description="Email address from which the thank-you email is sent", alias="thankYouFromEmail")
    thank_you_mail_subject: Optional[StrictStr] = Field(default=None, description="Subject line of the thank-you email", alias="thankYouMailSubject")
    thank_you_mail_message: Optional[StrictStr] = Field(default=None, description="Plain text message body of the thank-you email", alias="thankYouMailMessage")
    thank_you_sender: Optional[StrictStr] = Field(default=None, description="Sender ID for the thank-you email", alias="thankYouSender")
    confirm_from_name: Optional[StrictStr] = Field(default=None, description="Name displayed as the sender in the confirmation email", alias="confirmFromName")
    confirm_from_email: Optional[StrictStr] = Field(default=None, description="Email address from which the confirmation email is sent", alias="confirmFromEmail")
    confirm_mail_subject: Optional[StrictStr] = Field(default=None, description="Subject line of the confirmation email", alias="confirmMailSubject")
    confirm_mail_message: Optional[StrictStr] = Field(default=None, description="Plain text message body of the confirmation email", alias="confirmMailMessage")
    confirm_success_page: Optional[StrictStr] = Field(default=None, description="URL of the success page after confirmation", alias="confirmSuccessPage")
    confirm_sender: Optional[StrictStr] = Field(default=None, description="Sender ID for the confirmation email", alias="confirmSender")
    __properties: ClassVar[List[str]] = ["name", "type", "sendThankYouMail", "thankYouFromName", "thankYouFromEmail", "thankYouMailSubject", "thankYouMailMessage", "thankYouSender", "confirmFromName", "confirmFromEmail", "confirmMailSubject", "confirmMailMessage", "confirmSuccessPage", "confirmSender"]

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set([0, 1]):
            raise ValueError("must be one of enum values (0, 1)")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ListRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ListRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "type": obj.get("type"),
            "sendThankYouMail": obj.get("sendThankYouMail"),
            "thankYouFromName": obj.get("thankYouFromName"),
            "thankYouFromEmail": obj.get("thankYouFromEmail"),
            "thankYouMailSubject": obj.get("thankYouMailSubject"),
            "thankYouMailMessage": obj.get("thankYouMailMessage"),
            "thankYouSender": obj.get("thankYouSender"),
            "confirmFromName": obj.get("confirmFromName"),
            "confirmFromEmail": obj.get("confirmFromEmail"),
            "confirmMailSubject": obj.get("confirmMailSubject"),
            "confirmMailMessage": obj.get("confirmMailMessage"),
            "confirmSuccessPage": obj.get("confirmSuccessPage"),
            "confirmSender": obj.get("confirmSender")
        })
        return _obj


